Imports System.Runtime.CompilerServices

<Extension()> _
Public Class Dumper

    <Extension()> _
    Public Shared Function Write(ByVal valueList As IEnumerable) As String

        Dim valueEnum = valueList.GetEnumerator()
        While valueEnum.MoveNext
            Dim item As Object = valueEnum.Current
            Select Case True
                Case TypeOf item Is String
                    Console.WriteLine(item)
                Case TypeOf item Is System.Xml.XLinq.XElement
                    Console.WriteLine(item)
                Case Else
                    Dim piList As Reflection.PropertyInfo() = item.GetType.GetProperties
                    For Each pi As Reflection.PropertyInfo In piList
                        Console.ForegroundColor = ConsoleColor.DarkCyan
                        Console.Write(pi.Name & ": ")
                        Console.ForegroundColor = ConsoleColor.Blue
                        Console.Write(pi.GetValue(item, Nothing))
                        Console.Write(ControlChars.Tab)
                    Next
                    Console.WriteLine() 'next item
            End Select
        End While
        Return "done"
    End Function
End Class
